apps/participation/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.urls import path
from django.views.generic import TemplateView

from .views import CalendarView, CreateQuestionView, CreateTeamView, DeleteQuestionView, JoinTeamView, \
    MyParticipationDetailView, MyTeamDetailView, ParticipationDetailView, PhaseUpdateView, \
    SetParticipationReceiveParticipationView, SetParticipationSendParticipationView, TeamAuthorizationsView, \
    TeamDetailView, TeamLeaveView, TeamListView, TeamUpdateView, UpdateQuestionView, UploadVideoView


app_name = "participation"

urlpatterns = [
    path("create_team/", CreateTeamView.as_view(), name="create_team"),
    path("join_team/", JoinTeamView.as_view(), name="join_team"),
    path("teams/", TeamListView.as_view(), name="team_list"),
    path("team/", MyTeamDetailView.as_view(), name="my_team_detail"),
    path("team/<int:pk>/", TeamDetailView.as_view(), name="team_detail"),
    path("team/<int:pk>/update/", TeamUpdateView.as_view(), name="update_team"),
    path("team/<int:pk>/authorizations/", TeamAuthorizationsView.as_view(), name="team_authorizations"),
    path("team/leave/", TeamLeaveView.as_view(), name="team_leave"),
    path("detail/", MyParticipationDetailView.as_view(), name="my_participation_detail"),
    path("detail/<int:pk>/", ParticipationDetailView.as_view(), name="participation_detail"),
    path("detail/upload-video/<int:pk>/", UploadVideoView.as_view(), name="upload_video"),
    path("detail/<int:pk>/receive-participation/", SetParticipationReceiveParticipationView.as_view(),
         name="participation_receive_participation"),
    path("detail/<int:pk>/send-participation/", SetParticipationSendParticipationView.as_view(),
         name="participation_send_participation"),
    path("detail/<int:pk>/add-question/", CreateQuestionView.as_view(), name="add_question"),
    path("update-question/<int:pk>/", UpdateQuestionView.as_view(), name="update_question"),
    path("delete-question/<int:pk>/", DeleteQuestionView.as_view(), name="delete_question"),
    path("calendar/", CalendarView.as_view(), name="calendar"),
    path("calendar/<int:pk>/", PhaseUpdateView.as_view(), name="update_phase"),
    path("chat/", TemplateView.as_view(template_name="participation/chat.html"), name="chat")
]

apps/registration/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.urls import path

from .views import MyAccountDetailView, ResetAdminView, SignupView, UserDetailView, UserImpersonateView, \
    UserListView, UserResendValidationEmailView, UserUpdateView, UserUploadPhotoAuthorizationView, UserValidateView, \
    UserValidationEmailSentView

app_name = "registration"

urlpatterns = [
    path("signup/", SignupView.as_view(), name="signup"),
    path('validate_email/sent/', UserValidationEmailSentView.as_view(), name='email_validation_sent'),
    path('validate_email/resend/<int:pk>/', UserResendValidationEmailView.as_view(),
         name='email_validation_resend'),
    path('validate_email/<uidb64>/<token>/', UserValidateView.as_view(), name='email_validation'),
    path("user/", MyAccountDetailView.as_view(), name="my_account_detail"),
    path("user/<int:pk>/", UserDetailView.as_view(), name="user_detail"),
    path("user/<int:pk>/update/", UserUpdateView.as_view(), name="update_user"),
    path("user/<int:pk>/upload-photo-authorization/", UserUploadPhotoAuthorizationView.as_view(),
         name="upload_user_photo_authorization"),
    path("user/<int:pk>/impersonate/", UserImpersonateView.as_view(), name="user_impersonate"),
    path("user/list/", UserListView.as_view(), name="user_list"),
    path("reset-admin/", ResetAdminView.as_view(), name="reset_admin"),
]

corres2math/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

"""corres2math URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.contrib import admin
from django.urls import include, path
from django.views.defaults import bad_request, page_not_found, permission_denied, server_error
from django.views.generic import TemplateView
from registration.views import PhotoAuthorizationView

from .views import AdminSearchView

urlpatterns = [
    path('', TemplateView.as_view(template_name="index.html"), name='index'),
    path('about/', TemplateView.as_view(template_name="about.html"), name='about'),
    path('i18n/', include('django.conf.urls.i18n')),
    path('admin/doc/', include('django.contrib.admindocs.urls')),
    path('admin/', admin.site.urls, name="admin"),
    path('accounts/', include('django.contrib.auth.urls')),
    path('search/', AdminSearchView.as_view(), name="haystack_search"),

    path('api/', include('api.urls')),
    path('participation/', include('participation.urls')),
    path('registration/', include('registration.urls')),

    path('media/authorization/photo/<str:filename>/', PhotoAuthorizationView.as_view(), name='photo_authorization'),

    path('', include('eastereggs.urls')),
]

if 'cas_server' in settings.INSTALLED_APPS:  # pragma: no cover
    urlpatterns += [
        path('cas/', include('cas_server.urls', namespace="cas_server")),
    ]

handler400 = bad_request
handler403 = permission_denied
handler404 = page_not_found
handler500 = server_error

apps/participation/models.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

import os
import re

from corres2math.lists import get_sympa_client
from corres2math.matrix import Matrix, RoomPreset, RoomVisibility
from django.core.exceptions import ObjectDoesNotExist
from django.core.validators import RegexValidator
from django.db import models
from django.db.models import Index
from django.template.loader import render_to_string
from django.urls import reverse_lazy
from django.utils import timezone
from django.utils.crypto import get_random_string
from django.utils.text import format_lazy
from django.utils.translation import gettext_lazy as _


class Team(models.Model):
    """
    The Team model represents a real team that participates to the Correspondances.
    This only includes the registration detail.
    """
    name = models.CharField(
        max_length=255,
        verbose_name=_("name"),
        unique=True,
    )

    trigram = models.CharField(
        max_length=3,
        verbose_name=_("trigram"),
        help_text=_("The trigram must be composed of three uppercase letters."),
        unique=True,
        validators=[RegexValidator("[A-Z]{3}")],
    )

    access_code = models.CharField(
        max_length=6,
        verbose_name=_("access code"),
        help_text=_("The access code let other people to join the team."),
    )

    grant_animath_access_videos = models.BooleanField(
        verbose_name=_("Grant Animath to publish my video"),
        help_text=_("Give the authorisation to publish the video on the main website to promote the action."),
        default=False,
    )

    @property
    def email(self):
        """
        :return: The mailing list to contact the team members.
        """
        return f"equipe-{self.trigram.lower()}@{os.getenv('SYMPA_HOST', 'localhost')}"

    def create_mailing_list(self):
        """
        Create a new Sympa mailing list to contact the team.
        """
        get_sympa_client().create_list(
            f"equipe-{self.trigram.lower()}",
            f"Équipe {self.name} ({self.trigram})",
            "hotline",  # TODO Use a custom sympa template
            f"Liste de diffusion pour contacter l'équipe {self.name} des Correspondances",
            "education",
            raise_error=False,
        )
        if self.pk and self.participation.valid:  # pragma: no cover
            get_sympa_client().subscribe(self.email, "equipes", False, f"Equipe {self.name}")
            get_sympa_client().subscribe(self.email, f"probleme-{self.participation.problem}", False,
                                         f"Equipe {self.name}")
        else:
            get_sympa_client().subscribe(self.email, "equipes-non-valides", False)

    def delete_mailing_list(self):
        """
        Drop the Sympa mailing list, if the team is empty or if the trigram changed.
        """
        if self.participation.valid:  # pragma: no cover
            get_sympa_client().unsubscribe(self.email, "equipes", False)
            get_sympa_client().unsubscribe(self.email, f"probleme-{self.participation.problem}", False)
        else:
            get_sympa_client().unsubscribe(self.email, "equipes-non-valides", False)
        get_sympa_client().delete_list(f"equipe-{self.trigram}")

    def save(self, *args, **kwargs):
        if not self.access_code:
            # if the team got created, generate the access code, create the contact mailing list
            # and create a dedicated Matrix room.
            self.access_code = get_random_string(6)
            self.create_mailing_list()

            Matrix.create_room(
                visibility=RoomVisibility.private,
                name=f"#équipe-{self.trigram.lower()}",
                alias=f"equipe-{self.trigram.lower()}",
                topic=f"Discussion de l'équipe {self.name}",
                preset=RoomPreset.private_chat,
            )

        return super().save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse_lazy("participation:team_detail", args=(self.pk,))

    def __str__(self):
        return _("Team {name} ({trigram})").format(name=self.name, trigram=self.trigram)

    class Meta:
        verbose_name = _("team")
        verbose_name_plural = _("teams")
        indexes = [
            Index(fields=("trigram", )),
        ]


class Participation(models.Model):
    """
    The Participation model contains all data that are related to the participation:
    chosen problem, validity status, videos,...
    """
    team = models.OneToOneField(
        Team,
        on_delete=models.CASCADE,
        verbose_name=_("team"),
    )

    problem = models.IntegerField(
        choices=[(i, format_lazy(_("Problem #{problem:d}"), problem=i)) for i in range(1, 4)],
        null=True,
        default=None,
        verbose_name=_("problem number"),
    )

    valid = models.BooleanField(
        null=True,
        default=None,
        verbose_name=_("valid"),
        help_text=_("The video got the validation of the administrators."),
    )

    solution = models.OneToOneField(
        "participation.Video",
        on_delete=models.SET_NULL,
        related_name="participation_solution",
        null=True,
        default=None,
        verbose_name=_("solution video"),
    )

    received_participation = models.OneToOneField(
        "participation.Participation",
        on_delete=models.PROTECT,
        related_name="sent_participation",
        null=True,
        default=None,
        verbose_name=_("received participation"),
    )

    synthesis = models.OneToOneField(
        "participation.Video",
        on_delete=models.SET_NULL,
        related_name="participation_synthesis",
        null=True,
        default=None,
        verbose_name=_("synthesis video"),
    )

    def get_absolute_url(self):
        return reverse_lazy("participation:participation_detail", args=(self.pk,))

    def __str__(self):
        return _("Participation of the team {name} ({trigram})").format(name=self.team.name, trigram=self.team.trigram)

    class Meta:
        verbose_name = _("participation")
        verbose_name_plural = _("participations")


class Video(models.Model):
    """
    The Video model only contains a link and a validity status.
    """
    link = models.URLField(
        verbose_name=_("link"),
        help_text=_("The full video link."),
    )

    valid = models.BooleanField(
        null=True,
        default=None,
        verbose_name=_("valid"),
        help_text=_("The video got the validation of the administrators."),
    )

    @property
    def participation(self):
        """
        Retrives the participation that is associated to this video,
        whatever it is a solution or a synthesis.
        """
        try:
            # If this is a solution
            return self.participation_solution
        except ObjectDoesNotExist:
            # If this is a synthesis
            return self.participation_synthesis

    @property
    def platform(self):
        """
        According to the link, retrieve the platform that is used to upload the video.
        """
        if "youtube.com" in self.link or "youtu.be" in self.link:
            return "youtube"
        return "unknown"

    @property
    def youtube_code(self):
        """
        If the video is uploaded on Youtube, search in the URL the video code.
        """
        return re.compile("(https?://|)(www\\.|)(youtube\\.com/watch\\?v=|youtu\\.be/)([a-zA-Z0-9-_]*)?.*?")\
            .match(self.link).group(4)

    def as_iframe(self):
        """
        Generate the HTML code to embed the video in an iframe, according to the type of the host platform.
        """
        if self.platform == "youtube":
            return render_to_string("participation/youtube_iframe.html", context=dict(youtube_code=self.youtube_code))
        return None

    def __str__(self):
        return _("Video of team {name} ({trigram})")\
            .format(name=self.participation.team.name, trigram=self.participation.team.trigram)

    class Meta:
        verbose_name = _("video")
        verbose_name_plural = _("videos")


class Question(models.Model):
    """
    Question to ask to the team that sent a solution.
    """
    participation = models.ForeignKey(
        Participation,
        on_delete=models.CASCADE,
        verbose_name=_("participation"),
        related_name="questions",
    )

    question = models.TextField(
        verbose_name=_("question"),
    )

    def __str__(self):
        return self.question


class Phase(models.Model):
    """
    The Phase model corresponds to the dates of the phase.
    """
    phase_number = models.AutoField(
        primary_key=True,
        unique=True,
        verbose_name=_("phase number"),
    )

    description = models.CharField(
        max_length=255,
        verbose_name=_("phase description"),
    )

    start = models.DateTimeField(
        verbose_name=_("start date of the given phase"),
        default=timezone.now,
    )

    end = models.DateTimeField(
        verbose_name=_("end date of the given phase"),
        default=timezone.now,
    )

    @classmethod
    def current_phase(cls) -> "Phase":
        """
        Retrieve the current phase of this day
        """
        qs = Phase.objects.filter(start__lte=timezone.now(), end__gte=timezone.now())
        if qs.exists():
            return qs.get()
        qs = Phase.objects.filter(start__lte=timezone.now()).order_by("phase_number").all()
        return qs.last() if qs.exists() else None

    def __str__(self):
        return _("Phase {phase_number:d} starts on {start:%Y-%m-%d %H:%M} and ends on {end:%Y-%m-%d %H:%M}")\
            .format(phase_number=self.phase_number, start=self.start, end=self.end)

    class Meta:
        verbose_name = _("phase")
        verbose_name_plural = _("phases")

apps/participation/templates/participation/chat.html
{% extends "base.html" %}

{% load i18n %}

{% block content %}
    <div class="alert alert-warning">
    {% blocktrans trimmed %}
        The chat is located on the dedicated Matrix server:
    {% endblocktrans %}
    </div>

    <div class="alert text-center">
    <a class="btn btn-success" href="https://element.correspondances-maths.fr/#/room/#faq:correspondances-maths.fr" target="_blank">
        <i class="fas fa-server"></i> {% trans "Access to the Matrix server" %}
    </a>
    </div>

    <div class="alert alert-info">
    <p>
    {% blocktrans trimmed %}
        To connect to the server, you can select "Log in", then use your credentials of this platform to connect
        with the central authentication server, then you must trust the connection between the Matrix account and the
        platform. Finally, you will be able to access to the chat platform.
    {% endblocktrans %}
    </p>

    <p>
    {% blocktrans trimmed %}
        You will be invited in some basic rooms. You must confirm the invitations to join channels.
    {% endblocktrans %}
    </p>

    <p>
    {% blocktrans trimmed %}
        If you have any trouble, don't hesitate to contact us :)
    {% endblocktrans %}
    </p>
    </div>
{% endblock %}

apps/participation/templates/participation/create_team.html
{% extends "base.html" %}

{% load crispy_forms_filters i18n %}

{% block content %}
    <form method="post">
        <div id="form-content">
            {% csrf_token %}
            {{ form|crispy }}
        </div>
        <button class="btn btn-success" type="submit">{% trans "Create" %}</button>
    </form>
{% endblock content %}

apps/participation/templates/participation/join_team.html
{% extends "base.html" %}

{% load crispy_forms_filters i18n %}

{% block content %}
    <form method="post">
        <div id="form-content">
            {% csrf_token %}
            {{ form|crispy }}
        </div>
        <button class="btn btn-primary" type="submit">{% trans "Join" %}</button>
    </form>
{% endblock content %}

apps/participation/templates/participation/phase_form.html
{% extends "base.html" %}

{% load crispy_forms_filters i18n %}

{% block content %}
    <form method="post" action="{% url "participation:update_phase" pk=object.pk %}">
        <div id="form-content">
            {% csrf_token %}
            {{ form|crispy }}
        </div>
        <button class="btn btn-primary" type="submit">{% trans "Update" %}</button>
    </form>
{% endblock content %}

apps/participation/templates/participation/phase_list.html
{% extends "base.html" %}

{% load django_tables2 i18n static %}

{% block extracss %}
    <link rel="stylesheet" href="{% static "bootstrap_datepicker_plus/css/datepicker-widget.css" %}">
{% endblock %}

{% block contenttitle %}
    <h2>{% trans "Calendar" %}</h2>
{% endblock %}

{% block content %}
    <div id="form-content">
        {% render_table table %}

        {% trans "Update phase" as modal_title %}
        {% trans "Update" as modal_button %}
        {% include "base_modal.html" with modal_id="updatePhase" %}
    </div>
{% endblock %}

{% block extrajavascript %}
{% if user.registration.is_admin %}
    <script>
        $("tr").click(function () {
            let modalBody = $("#updatePhaseModal div.modal-body");
            if (!modalBody.html().trim())
                modalBody.load("{% url "participation:calendar" %}" + $(this).data("id") + "/ #form-content");
            $("#updatePhase-form").attr("action", "{% url "participation:calendar" %}" + $(this).data("id") + "/")
            $("#updatePhaseModal").modal();
        })
    </script>
{% endif %}
{% endblock %}

apps/participation/templates/participation/question_confirm_delete.html
{% extends "base.html" %}

{% load crispy_forms_filters i18n %}

{% block content %}
    <form method="post">
        <div id="form-content">
            <div class="alert alert-danger">
                {% trans "Are you sure you want to delete this question?" %}
            </div>
            {% csrf_token %}
            {{ form|crispy }}
        </div>
        <button class="btn btn-danger" type="submit">{% trans "Delete" %}</button>
    </form>
{% endblock content %}

apps/participation/templates/participation/question_form.html
{% extends "base.html" %}

{% load crispy_forms_filters i18n %}

{% block content %}
    <form method="post">
        <div id="form-content">
            {% csrf_token %}
            {{ form|crispy }}
        </div>
        <button class="btn btn-primary" type="submit">{% trans "Send" %}</button>
    </form>
{% endblock content %}

apps/participation/templates/participation/receive_participation_form.html
{% extends "base.html" %}

{% load crispy_forms_filters i18n %}

{% block content %}
    <form method="post">
        <div id="form-content">
            {% csrf_token %}
            {{ form|crispy }}
        </div>
        <button class="btn btn-primary" type="submit">{% trans "Update" %}</button>
    </form>
{% endblock content %}

apps/participation/templates/participation/team_detail.html
{% extends "base.html" %}

{% load i18n %}
{% load crispy_forms_filters %}

{% block content %}

    <div class="card bg-light shadow">
        <div class="card-header text-center">
            <h4>{{ team.name }}</h4>
        </div>
    <div class="card-body">
        <dl class="row">
            <dt class="col-sm-6 text-right">{% trans "Name:" %}</dt>
            <dd class="col-sm-6">{{ team.name }}</dd>

            <dt class="col-sm-6 text-right">{% trans "Trigram:" %}</dt>
            <dd class="col-sm-6">{{ team.trigram }}</dd>

            <dt class="col-sm-6 text-right">{% trans "Email:" %}</dt>
            <dd class="col-sm-6"><a href="mailto:{{ team.email }}">{{ team.email }}</a></dd>

            <dt class="col-sm-6 text-right">{% trans "Access code:" %}</dt>
            <dd class="col-sm-6">{{ team.access_code }}</dd>

            <dt class="col-sm-6 text-right">{% trans "Coachs:" %}</dt>
            <dd class="col-sm-6">
                {% for coach in team.coachs.all %}
                    <a href="{% url "registration:user_detail" pk=coach.user.pk %}">{{ coach }}</a>{% if not forloop.last %},{% endif %}
                {% empty %}
                    {% trans "any" %}
                {% endfor %}
            </dd>

            <dt class="col-sm-6 text-right">{% trans "Participants:" %}</dt>
            <dd class="col-sm-6">
                {% for student in team.students.all %}
                    <a href="{% url "registration:user_detail" pk=student.user.pk %}">{{ student }}</a>{% if not forloop.last %},{% endif %}
                {% empty %}
                    {% trans "any" %}
                {% endfor %}
            </dd>

            <dt class="col-sm-6 text-right">{% trans "Chosen problem:" %}</dt>
            {% trans "any" as any %}
            <dd class="col-sm-6">{{ team.participation.get_problem_display|default:any }}</dd>

            <dt class="col-sm-6 text-right">{% trans "Grant Animath to publish our video:" %}</dt>
            <dd class="col-sm-6">{{ team.grant_animath_access_videos|yesno }}</dd>

            <dt class="col-sm-6 text-right">{% trans "Authorizations:" %}</dt>
            <dd class="col-sm-6">
                {% for student in team.students.all %}
                    {% if student.photo_authorization %}
                        <a href="{{ student.photo_authorization.url }}" data-turbolinks="false">{{ student }}</a>{% if not forloop.last %},{% endif %}
                    {% else %}
                        {{ student }} ({% trans "Not uploaded yet" %}){% if not forloop.last %},{% endif %}
                    {% endif %}
                {% endfor %}
            </dd>
        </dl>
    </div>
    <div class="card-footer text-center">
        <button class="btn btn-primary" data-toggle="modal" data-target="#updateTeamModal">{% trans "Update" %}</button>
        {% if not team.participation.valid %}
            <button class="btn btn-danger" data-toggle="modal" data-target="#leaveTeamModal">{% trans "Leave" %}</button>
        {% endif %}
    </div>
    </div>

    <hr>

    {% if team.participation.valid %}
        <div class="text-center">
            <a class="btn btn-info" href="{% url "participation:participation_detail" pk=team.participation.pk %}">
                <i class="fas fa-video"></i> {% trans "Access to team participation" %} <i class="fas fa-video"></i>
            </a>
        </div>
    {% elif team.participation.valid == None %} {# Team did not ask for validation #}
        {% if user.registration.participates %}
            {% if can_validate %}
                <div class="alert alert-info">
                    {% trans "Your team has at least 3 members and all photo authorizations were given: the team can be validated." %}
                    <div class="text-center">
                        <form method="post">
                            {% csrf_token %}
                            {{ request_validation_form|crispy }}
                            <button class="btn btn-success" name="request-validation">{% trans "Submit my team to validation" %}</button>
                        </form>
                    </div>
                </div>
            {% else %}
                <div class="alert alert-warning">
                    {% trans "Your team must be composed of 3 members and each member must upload its photo authorization and confirm its email address." %}
                </div>
            {% endif %}
        {% else %}
            <div class="alert alert-warning">
            {% trans "This team didn't ask for validation yet." %}
            </div>
        {% endif %}
    {% else %}  {# Team is waiting for validation #}
        {% if user.registration.participates %}
            <div class="alert alert-warning">
                {% trans "Your validation is pending." %}
            </div>
        {% else %}
            <div class="alert alert-info">
                {% trans "The team requested to be validated. You may now control the authorizations and confirm that they can participate." %}
            </div>
             <form method="post">
                {% csrf_token %}
                {{ validation_form|crispy }}
                <div class="input-group btn-group">
                    <button class="btn btn-success" name="validate" type="submit">{% trans "Validate" %}</button>
                    <button class="btn btn-danger" name="invalidate" type="submit">{% trans "Invalidate" %}</button>
                </div>
             </form>
        {% endif %}
    {% endif %}

    {% trans "Update team" as modal_title %}
    {% trans "Update" as modal_button %}
    {% url "participation:update_team" pk=team.pk as modal_action %}
    {% include "base_modal.html" with modal_id="updateTeam" %}

    {% trans "Leave team" as modal_title %}
    {% trans "Leave" as modal_button %}
    {% url "participation:team_leave" as modal_action %}
    {% include "base_modal.html" with modal_id="leaveTeam" modal_button_type="danger" %}
{% endblock %}

{% block extrajavascript %}
    <script>
        $(document).ready(function() {
            $('button[data-target="#updateTeamModal"]').click(function() {
                let modalBody = $("#updateTeamModal div.modal-body");
                if (!modalBody.html().trim())
                    modalBody.load("{% url "participation:update_team" pk=team.pk %} #form-content");
            });
            $('button[data-target="#leaveTeamModal"]').click(function() {
                let modalBody = $("#leaveTeamModal div.modal-body");
                if (!modalBody.html().trim())
                    modalBody.load("{% url "participation:team_leave" %} #form-content");
            });
        });
    </script>
{% endblock %}

apps/participation/templates/participation/team_leave.html
{% extends "base.html" %}

{% load i18n %}

{% block content %}
    <form method="post">
        <div class="alert alert-warning" id="form-content">
            {% csrf_token %}
            {% trans "Are you sure that you want to leave this team?" %}
        </div>
        <button class="btn btn-danger" type="submit">{% trans "Leave" %}</button>
    </form>
{% endblock %}

apps/participation/templates/participation/team_list.html
{% extends "base.html" %}

{% load django_tables2 i18n %}

{% block contenttitle %}
    <h1>{% trans "All teams" %}</h1>
{% endblock %}

{% block content %}
    <div id="form-content">
        {% render_table table %}
    </div>
{% endblock %}

apps/participation/templates/participation/upload_video.html
{% extends "base.html" %}

{% load crispy_forms_filters i18n %}

{% block content %}
    <form method="post">
        <div id="form-content">
            {% csrf_token %}
            {{ form|crispy }}
        </div>
        <button class="btn btn-success" type="submit">{% trans "Upload" %}</button>
    </form>
{% endblock content %}

apps/participation/templates/participation/youtube_iframe.html
<div style="position: relative; width: 100%; padding-bottom: 56.25%;">
    <iframe src="https://www.youtube.com/embed/{{ youtube_code }}"
            frameborder="0"
            style="position: absolute; top: 0; left: 0; width: 100%; height: 100%;"
            allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
            allowfullscreen>
    </iframe>
</div>